/*
 *  decode mimeheader
 */

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#ifndef  include_dirent
#define  include_dirent
#endif   /* !include_dirent */
#include <errno.h>
#include <time.h>
#include <stdarg.h>
#include <signal.h>

#include	"kanjilib.h"
#include	"mime.h"

#ifndef boolean
#define boolean char
#define TRUE (1)
#define FALSE (0)
#endif

#define MAXBUF 5000

#define mime_charB64(c)  (((c) < 0 || (c) > 0x7f) ? -1 : \
			  mime_base64_index[(c)])
#define mime_charB16(c)  (((c) < 0 || (c) > 0x7f) ? -1 : \
			  mime_base16_index[(c)])

static char	mime_base64_basis[] =
  "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

static char	mime_base64_index[] = {
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, -1, -1, -1, 63,
  52, 53, 54, 55, 56, 57, 58, 59, 60, 61, -1, -1, -1, -1, -1, -1,
  -1,  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14,
  15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, -1, -1, -1, -1, -1,
  -1, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40,
  41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, -1, -1, -1, -1, -1,
};

static char	mime_base16_basis[] = "0123456789ABCDEF";
static char	mime_base16_index[] = {
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
     0,  1,  2,  3,  4,  5,  6,  7,  8,  9, -1, -1, -1, -1, -1, -1,
    -1, 10, 11, 12, 13, 14, 15, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, 10, 11, 12, 13, 14, 15, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
};

static char	mime_especials[] = "()<>@,;:\\/[]?.=";

static char	*mime_encodeQ();
static char	*mime_decodeQ();
static char	*mime_encodeB64();
static char	*mime_decodeB64();
static char	*mime_outputB64();
static int	mime_boundaryB64();
static char	*strcheck();
static char	*strcasecheck();

void print_warning(char *s)
{
	fprintf(stderr, "mdecode: %s\n", s);
}

char  *strindex(str1 ,str2)
     char   *str1;
     char   *str2;
{
  int length;

  length = strlen(str2);
  while (*str1) {
    if (!strncasecmp(str1, str2, length)) {
      return(str1);
    }
    str1++;
  }
  return(NULL);
}

/*
 * MIME ǥ
 * (ISO-2022-JP2 бԴ)
 */

int	mime_decode(ptr1, ptr2)
     char	*ptr1;
     char	*ptr2;
{
  int	mime;
  int	encode;
  char	*ptr3, *ptr4, *ptr5;
  char	buff[BUFF_SIZE];

  mime = 0;
  ptr4 = NULL;
  while (*ptr1) {
    if (ptr3 = strcheck(ptr1, MIME_ENCODE_START)) {
      ptr5 = ptr3;
      if (!(ptr3 = strcasecheck(ptr5, MIME_CHARSET_ISO2022_1))) {
	    ptr3 = strcasecheck(ptr5, MIME_CHARSET_ASCII);
      }
      if (ptr3) {
	    if (*ptr3++ == MIME_SEPARATER) {
	      switch (*ptr3++) {
	      case MIME_ENCODE_QP:
	        encode = 1;
	        break;
	      case MIME_ENCODE_BASE64:
	         encode = 2;
	         break;
	      default:
	        encode = 0;
	        break;
	      }
	      if (encode) {
	        if (*ptr3++ == MIME_SEPARATER) {
	          ptr1 = ptr3;
	          if (ptr3 = strindex(ptr1, MIME_ENCODE_END)) {
		        strcpy(buff, ptr1);
		        buff[ptr3 - ptr1] = '\0';
		        mime = 1;
		        if (ptr4) {
		          ptr2 = ptr4;
		          ptr4 = NULL;
		        }
		        if (encode == 1) {
		          ptr2 = mime_decodeQ(buff, ptr2);
		        } else {
		          ptr2 = mime_decodeB64(buff, ptr2, NULL, 0);
		        }
		        ptr1 = ptr3 + sizeof(MIME_ENCODE_END) - 1;
		        continue;
	          }
	        }
	      }
	    }
      }
    }
    ptr4 = NULL;
    *ptr2++ = *ptr1++;
  }
  *ptr2 = '\0';
  return(mime);
}

/*
 * MIME QP ǥ
 */

static char	*mime_decodeQ(ptr1, ptr2)
     unsigned char	*ptr1;
     unsigned char	*ptr2;
{
  while (*ptr1) {
    if (*ptr1 == MIME_PAD_CHAR) {
      ptr1++;
      if (isdigit(*ptr1)) {
	*ptr2 = *ptr1++ - '0';
      } else if ((*ptr1 >= 'A') && (*ptr1 <= 'F')) {
	*ptr2 = *ptr1++ - 'A'+ 0xa;
      } else if ((*ptr1 >= 'a') && (*ptr1 <= 'f')) {
	*ptr2 = *ptr1++ - 'a'+ 0xa;
      } else {
	print_warning("Ignoring unrecognized code in MIME-QP.");
	continue;
      }
      *ptr2 = (*ptr2) << 4;
      if (isdigit(*ptr1)) {
	*ptr2 |= *ptr1++ - '0';
	ptr2++;
      } else if ((*ptr1 >= 'A') && (*ptr1 <= 'F')) {
	*ptr2 |= *ptr1++ - 'A'+ 0xa;
	ptr2++;
      } else if ((*ptr1 >= 'a') && (*ptr1 <= 'f')) {
	*ptr2 |= *ptr1++ - 'a'+ 0xa;
	ptr2++;
      } else {
	print_warning("Ignoring unrecognized code in MIME-QP.");
	continue;
      }
    } else {
      *ptr2++ = *ptr1++;
    }
  }
  return((char*)ptr2);
}

/*
 * MIME BASE64 ǥ
 */

static char	*mime_decodeB64(ptr1, ptr2, boundaries, boundaryct)
     char	*ptr1;
     char	*ptr2;
     char	**boundaries;
     int	*boundaryct;
{
  char	buff[BUFF_SIZE];
  char	*ptr3;
  int	code1, code2, code3, code4;
  int	newline = 1;
  int	finish = 0;

  while (code1 = *ptr1++) {
    if (isspace(code1)) {
      if (code1 == '\n') {
	newline = 1;
      } else {
	newline = 0;
      }
      continue;
    }
    if (newline && boundaries && (code1 == '-')) {
      ptr1--;
      ptr3 = buff;
      while (*ptr1) {
	*ptr3++ = *ptr1;
	if (*ptr1++ == '\n') {
	  break;
	}
      };
      *ptr3 = '\0';
      if (boundaries && (buff[0] == '-') && (buff[1] == '-')
	  && mime_boundaryB64(buff, boundaries, boundaryct)) {
	*ptr2 = '\0';
	return(ptr2);
      }
      print_warning("Ignoring unrecognized boundary line in MIME-B64.");
      continue;
    }
    if (finish) {
      continue;
    }
    newline = 0;
    do {
      code2 = *ptr1++;
    } while (code2 && isspace(code2));
    if (code2) {
      do {
	code3 = *ptr1++;
      } while (code3 && isspace(code3));
      if (code3) {
	do {
	  code4 = *ptr1++;
	} while (code4 && isspace(code4));
	if (code4) {
	  if ((code1 == MIME_PAD_CHAR) || (code2 == MIME_PAD_CHAR)) {
	    finish = 1;
	    continue;
	  }
	  code1 = mime_charB64(code1);
	  code2 = mime_charB64(code2);
	  *ptr2++ = ((code1 << 2) | ((code2 & 0x30) >> 4));
	  if (code3 == MIME_PAD_CHAR) {
	    finish = 1;
	  } else {
	    code3 = mime_charB64(code3);
	    *ptr2++ = (((code2 & 0x0f) << 4) | ((code3 & 0x3c) >> 2));
	    if (code4 == MIME_PAD_CHAR) {
	      finish = 1;
	    } else {
	      code4 = mime_charB64(code4);
	      *ptr2++ = (((code3 & 0x03) << 6) | code4);
	    }
	  }
	  continue;
	}
      }
    }
    print_warning("Unexpected EOL in MIME-B64.");
    break;
  }
  *ptr2 = '\0';
  return(ptr2);
}

static char	*mime_outputB64(code1, code2, code3, pad, ptr)
     int	code1, code2, code3;
     int	pad;
     char	*ptr;
{
  *ptr++ = mime_base64_basis[code1 >> 2];
  *ptr++ = mime_base64_basis[((code1 & 0x3) << 4) | ((code2 & 0xF0) >> 4)];
  switch (pad) {
  case 2:
    *ptr++ = MIME_PAD_CHAR;
    *ptr++ = MIME_PAD_CHAR;
    break;
  case 1:
    *ptr++ = mime_base64_basis[((code2 & 0xF) << 2) | ((code3 & 0xC0) >> 6)];
    *ptr++ = MIME_PAD_CHAR;
    break;
  case 0:
  default:
    *ptr++ = mime_base64_basis[((code2 & 0xF) << 2) | ((code3 & 0xC0) >> 6)];
    *ptr++ = mime_base64_basis[code3 & 0x3F];
    break;
  }
  return(ptr);
}

static int	mime_boundaryB64(ptr, boundaries, boundaryct)
     char	*ptr;
     char	**boundaries;
     int	*boundaryct;
{
  char		buff[2048];
  register int	i;

  for (i = 0; i < *boundaryct; ++i) {
    if (!strncmp(ptr, boundaries[i], strlen(boundaries[i]))) {
      strcpy(buff, boundaries[i]);
      strcat(buff, "--\n");
      if (!strcmp(buff, ptr)) {
	*boundaryct = i;
      }
      return(1);
    }
  }
  return(0);
}

/*
 * ʸӡܥݥ󥿰ư(ʸʸ)
 */

static char	*strcheck(ptr1, ptr2)
     char	*ptr1;
     char	*ptr2;
{
  register int	n;

  n = strlen(ptr2);
  if (strncmp(ptr1, ptr2, n)) {
    return(NULL);
  }
  return(ptr1 + n);
}

/*
 * ʸӡܥݥ󥿰ư(ʸʸ̤ʤ)
 */

static char	*strcasecheck(ptr1, ptr2)
     char	*ptr1;
     char	*ptr2;
{
  register int	n;

  n = strlen(ptr2);
  if (strncasecmp(ptr1, ptr2, n)) {
    return(NULL);
  }
  return(ptr1 + n);
}

int main(argc, argv)
	int        argc;
	char       *argv[];
{
	boolean body_start= FALSE, only_header=FALSE, file_out=FALSE,
			read_stdin= FALSE;
	int i= 1;
	char *buf, *buf2, *p;
	FILE *fp;

	buf2= (char *)malloc(MAXBUF * sizeof(char) +2);

	for (i= 1; argc > i; i++) {
		p= argv[i];
		if (*p == '-') {
			if (*++p == 'h') {
				only_header= TRUE;
			} else if (*p == 'c') {
				read_stdin= TRUE;
			} else if (*p == 'o') {
				if (!(fp= fopen(argv[++i], "w"))) {
					fprintf(stderr, "mdecode: tmpfile:'%s'. errno:%d\n", argv[i],errno);
					print_warning("cannot open temporary file");
					exit(2);
				}
				file_out= TRUE;
			}
		} else {
			mime_decode(argv[i],buf2);
			if (fputs(buf2, stdout) == EOF) {
				print_warning("output error");
				exit(1);
			}
		}
	}
	if (!read_stdin)
		exit(0);

	buf = (char *)malloc(MAXBUF * sizeof(char) +2);
	while (fgets(buf, MAXBUF, stdin) != NULL) {
		if (strlen(buf) == 1) body_start= TRUE;
		if (body_start & only_header)
			strcpy(buf2, buf);
		else
			mime_decode(buf, buf2);
		if (file_out) {
			if (fputs(buf2, fp) == EOF) {
				print_warning("output temporary file error");
				fclose(fp);
				exit(1);
			}
		} else {
			if (fputs(buf2, stdout) == EOF) {
				print_warning("output error");
				exit(1);
			}
		}
	}
	if (file_out) fclose(fp);

	if (ferror(stdin)) {
		print_warning("input error");
	}
}

